#include <bits/stdc++.h>

using namespace std;

typedef pair<int, int> pii;

const int N = 1e5 + 1;

vector<pii> g[N];
vector<int> used(N);
vector<int> lvl(N);
vector<int> dist(N);

void dfs(int v) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (used[to.first] == 0) {
            lvl[to.first] = lvl[v] + 1;
            dist[to.first] = dist[v] + to.second;
            dfs(to.first);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int n, k;
    cin >> n >> k;
    for (int i = 2; i <= n ; i++) {
        int to, w;
        cin >> to >> w;
        g[i].emplace_back(to, w);
        g[to].emplace_back(i, w);
    }
    int mx = 0;
    pii ans;
    dfs(1);
    for (int i = 1; i <= n; i++) {
        if (lvl[i] >= mx) {
            mx = lvl[i];
            ans.first = min(dist[i], ans.first);
            ans.second = lvl[i];
        }
    }
    cout << ans.second << ' ' << ans.first << "\n";
    return 0;
}